<?php

namespace Drupal\basicshib\Plugin;

/**
 *
 */
interface UserProviderPluginInterface {

  /**
   * Load an existing user.
   *
   * @param string $name
   *
   * @return
   */
  public function loadUserByName(string $name);

  /**
   * Create a new user. The user will be saved by the login controller.
   *
   * @param string $name
   * @param string $mail
   *
   * @return
   *   The user, or null if one cannot be created.
   */
  public function createUser(string $name, string $mail);

}
